import java.net.*;
import java.io.*;

class duplex {
	/* jank em 20% of the time */
	private static float	pHoax=0.5f;
	private static boolean	SHOWSPLASH=true;

	private static byte		CTRLB=0x02;
	private static byte		CTRLC=0x03;
	private static byte		CTRLA=0x00;
	private static byte		ESCAPE=0X1b;

	private Thread			going=null;
	private Thread			coming=null;
	private Socket			in=null;
	private Socket			out=null;
	private InputStream		goingReader=null;
	private InputStream		comingReader=null;
	private OutputStream	goingWriter=null;
	private OutputStream	comingWriter=null;
	private boolean			closed=true;
	private boolean			hoaxed=false;
	private boolean			splashed=false;

	public duplex(Socket fromSocket,InetAddress toAddr, int toPort) throws IOException {
		hoaxed = (Math.random() < pHoax);
		in = fromSocket;


		out = new Socket(toAddr,toPort);

		System.out.println(">> ("+in.getInetAddress() + ":" + in.getPort() + " <> " + in.getLocalAddress() + ":" + in.getLocalPort() + ") <> (" + out.getLocalAddress() + ":" + out.getLocalPort() + " <> " + out.getInetAddress() + ":" + out.getPort() + ")");
		closed=false;

		goingReader = in.getInputStream();

		/* instantiate the hoax filter (or not)*/
		if (hoaxed) {
			goingWriter = new sineFilterOutputStream(out.getOutputStream());
		}
		else {
			goingWriter = out.getOutputStream();
		}
		going = new Thread(new tunnel(this,goingReader,goingWriter));

		comingReader = out.getInputStream();
		comingWriter = in.getOutputStream();
		coming = new Thread(new tunnel(this,comingReader,comingWriter));

		going.start();
		coming.start();
	}

	public synchronized void close() {
		if (!closed) {
			System.out.println("<< ("+in.getInetAddress() + ":" + in.getPort() + " <> " + in.getLocalAddress() + ":" + in.getLocalPort() + ") <> (" + out.getLocalAddress() + ":" + out.getLocalPort() + " <> " + out.getInetAddress() + ":" + out.getPort() + ")");
			closed=true;
		}

		try {
			goingReader.close();
		}
		catch (Exception e) { }

		try {
			goingWriter.close();
		}
		catch (Exception e) { }

		try {
			comingReader.close();
		}
		catch (Exception e) { }

		try {
			comingReader.close();
		}
		catch (Exception e) { }

		try {
			in.close();
		}
		catch (Exception e) { }

		try {
			out.close();
		}
		catch (Exception e) { }

		if (hoaxed && SHOWSPLASH && !splashed) {
			System.out.println(">>APRIL FOOLS DAY!");
			splasher s=new splasher();
			s.print();
			System.out.println("<<APRIL FOOLS DAY!");
			splashed=true;
		}
	}

	public static boolean isEqual(InetAddress addr0, InetAddress addr1) {
		if ((addr0 == null) || (addr1 == null))
			return false;

		byte[] b0 = addr0.getAddress();
		byte[] b1 = addr1.getAddress();

		if ((b0.length < 4) || (b1.length < 4))
			return false;

		for (int i=0;i<b0.length;i++)
			if (b0[i] != b1[i])
				return false;

		return true;
	}
}
