import java.io.*;

public class sineFilterOutputStream extends FilterOutputStream {
	protected static int	ESCAPE=0x1b;
	private static int		OFFSET=-20;

	private byte[]			store=new byte[10];
	private int				cstore=0;
	private byte			state=0;
    private int             x=0;

	public sineFilterOutputStream(OutputStream stream) {
		super(stream);
	}

	public void write(byte[] b) throws IOException {
		write(b,0,b.length);
	}

	public void write(byte[] b, int off, int len) throws IOException {
		for (int i=0;i<len;i++)
			write((int)b[off+i]);
	}

	private void reset() {
		state=0;
		cstore=0;
	}

	public void write(int b) throws IOException {
		byte[] yb = (new String("Y")).getBytes();

		if (b == ESCAPE) {
			if (cstore > 0)
				out.write(store,0,cstore);
			if (state==4)
				out.write(yb,0,yb.length);
			reset();
			out.write(b);
		}
		else if (((b=='*') && (state==0))
				|| ((b=='p') && (state==1))) {
			state++;
			out.write(b);
		}
        else if ((b=='x') && (state==2)) {
            try {
                x = Integer.parseInt(new String(store,0,cstore));
                cstore=0;
                state++;
                out.write(b);
            }
            catch (NumberFormatException e) {
                out.write(b);
                state=-1;
            }
        }
		else if (FilterUtils.isNumeric(b) && (state==2)) {
            if (cstore < store.length)
                store[cstore++]=(new Integer(b)).byteValue();
            else
                state=-1;
			out.write(b);
		}
		else if (FilterUtils.isNumeric(b) && (state==3)) {
			if (cstore < store.length) {
				store[cstore++]=(new Integer(b)).byteValue();
			}
			else {
				state=-1;
				out.write(store);
			}
		}
		else if ((b=='Y')&&(state==3)) {
            state=-1;
            try {
                int nc = Integer.parseInt(new String(store,0,cstore));
                nc += (int)(40*Math.sin(x/100.0));
                out.write(Integer.toString(nc).getBytes());
                out.write(b);
            }
            catch (NumberFormatException e) {
                out.write(store,0,cstore);
            }
            reset();
		}
		else {
			if (cstore > 0 && state==3)
				out.write(store,0,cstore);
				
			out.write(b);
			state=-1;
			reset();
		}
	}

	/**
		TESTING
	**/
	public static void main(String[] args) {
		byte[] b = new byte[1024];
		int len=0;
		try {
			FileInputStream fi = new FileInputStream("test.log");
			sineFilterOutputStream fo = new sineFilterOutputStream(new FileOutputStream("output"));

			while ((len = fi.read(b)) > 0) {
				fo.write(b,0,len);
			}
			fi.close();
			fo.close();
		}
		catch (IOException e) {
			System.err.println(e);
		}
	}
}
